; =============================================================================
;	Z80 Utility
; -----------------------------------------------------------------------------
;	2019/07/04	t.hara
; =============================================================================

; =============================================================================
;	RL16	{BC|DE|HL}
;
;	rbg[eCgBbit0 ɂ CF ̒lACF ɂ͂͂ݏo bit15 i[B
; =============================================================================
RL16	macro	@reg16
			if		reg16 == "BC"
				RL		C
				RL		B
			elseif	reg16 == "DE"
				RL		E
				RL		D
			elseif	reg16 == "HL"
				RL		L
				RL		H
			else
				error	"Unsupported argument \" + reg16 + "\" in RL16 macro."
			endif
		endm

; =============================================================================
;	RR16	{BC|DE|HL}
;
;	Erbg[eCgBbit15 ɂ CF ̒lACF ɂ͂͂ݏo bit0 i[B
; =============================================================================
RR16	macro	@reg16
			if		reg16 == "BC"
				RR		B
				RR		C
			elseif	reg16 == "DE"
				RR		D
				RR		E
			elseif	reg16 == "HL"
				RR		H
				RR		L
			else
				error	"Unsupported argument \" + reg16 + "\" in RR16 macro."
			endif
		endm

; =============================================================================
;	SLA16	{BC|DE|HL}
;
;	Zp1bitVtgBbit0  0 ɂȂB
; =============================================================================
SLA16	macro	@reg16
			if		reg16 == "BC"
				SLA		C
				RL		B
			elseif	reg16 == "DE"
				SLA		E
				RL		D
			elseif	reg16 == "HL"
				SLA		L
				RL		H
			else
				error	"Unsupported argument \" + reg16 + "\" in SLA16 macro."
			endif
		endm

; =============================================================================
;	SRA16	{BC|DE|HL}
;
;	Zp1bitEVtgBbit15 ͕ωB
; =============================================================================
SRA16	macro	@reg16
			if		reg16 == "BC"
				SRA		B
				RR		C
			elseif	reg16 == "DE"
				SRA		D
				RR		E
			elseif	reg16 == "HL"
				SRA		H
				RR		L
			else
				error	"Unsupported argument \" + reg16 + "\" in SRA16 macro."
			endif
		endm

; =============================================================================
;	SRL16	{BC|DE|HL}
;
;	_1bitEVtgBbit15  0 ɂȂB
; =============================================================================
SRL16	macro	@reg16
			if		reg16 == "BC"
				SRL		B
				RR		C
			elseif	reg16 == "DE"
				SRL		D
				RR		E
			elseif	reg16 == "HL"
				SRL		H
				RR		L
			else
				error	"Unsupported argument \" + reg16 + "\" in SRL16 macro."
			endif
		endm

; =============================================================================
;	BYTE_ALIGN	align
;
;	AhX align Ŏ鐔l̔{ ɂȂ܂ŃpfBO
; =============================================================================
BYTE_ALIGN	MACRO	align
			if FILE_ADDRESS % align
				defs	" " * (align - (FILE_ADDRESS % align))
			endif
		endm
